<?php
/**
* Plugin Cameleon
*
* @package	PLX
* @version	1.0
* @date	07/02/17
* @author Bronco
**/
class Cameleon extends plxPlugin {
	public $themes 		;
	public $theme_path  ;
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		$themes=array();
		$this->getThemePath();

		$files = plxGlob::getInstance(PLX_ROOT.$this->theme_path, true);
		$theme_folders = $files->query("/[a-z0-9-_\.\(\)]+/i", "", "sort");
		

		# normalisation des noms de dossiers
		if($theme_folders) {
			$theme_folders = array_flip($theme_folders);
			foreach($theme_folders as $t=>$nb){
				$f 				=$this->theme_path.$t;
				$norm 			=$this->normalize($t);
				$themes[$norm] 	=true;
				if ($t!=$norm){
					rename($f,$this->theme_path.$norm);
				}
			}
		}
		$this->themes=$themes;
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('plxShowConstruct','plxShowConstruct');		
	}

	# Activation / desactivation
	public function OnActivate() {
		# code à executer à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################


	########################################
	# normalize
	########################################
	# Description:
	public function normalize($chaine=''){
		$chaine=trim(mb_strtolower($chaine));
		$chaine = str_replace(' ','_',$chaine);
		$chaine=preg_replace('#[^a-z-0-9éèêâàôîûçïöüëäáíóú]#','',$chaine);
        // &eacute => é ; é => é : met tout en UTF8 pour uniformiser
        $chaine = html_entity_decode($chaine, ENT_QUOTES, 'UTF-8');
        // é => &eacute; : met tout en iso avec les &xxxx;
        $chaine = htmlentities($chaine, ENT_QUOTES, 'UTF-8');
        
        // &eacute => e : décortique la signification des « &eacute », où la première lettre est celui qu’on cherche
        $chaine = preg_replace('#&(.)(acute|grave|circ|uml|cedil|tilde|ring|slash|caron);#', '$1', $chaine);
    	return str_replace("'",'',$chaine); //vire aussi les apostrophes
	}
	########################################
	# getThemePath
	########################################
	# Description:
	public function getThemePath(){
		$file 		=file_get_contents(path('XMLFILE_PARAMETERS'));
		preg_match('#name="racine_themes"><!\[CDATA\[([^\]]+)#',$file,$path);
		$this->theme_path=empty($path[1])?'':$path[1];
		return $this->theme_path;
	}

	########################################
	# plxShowConstruct
	########################################
	# Description:
	public function plxShowConstruct(){
		$plxMotor = plxMotor::getInstance();
		echo '<?php
		$themes=$this->plxMotor->plxPlugins->aPlugins["Cameleon"]->themes;

		if ($this->catId()!=""&&$this->catId()!="home"){
			$theme=sprintf("%\'.03d",$this->catId());// numéro de la catégorie
			$theme=empty($this->plxMotor->aCats[$theme]["name"])?"defaut":$this->plxMotor->aCats[$theme]["name"];
		}else
		if ($this->staticId()!=""&&$this->staticId()!="article"){
			$theme=sprintf("%\'.03d",$this->staticId());
			$theme=empty($this->plxMotor->aStats[$theme]["name"])?"defaut":$this->plxMotor->aStats[$theme]["name"];
		}else
		if($this->plxMotor->plxRecord_arts->f("categorie")){			
			$cats=explode(",",$this->plxMotor->plxRecord_arts->f("categorie"));
			foreach($cats as $nb=>$cat){ 
				if (!empty($this->plxMotor->aCats[$cat]["name"])){
					$temp=$this->plxMotor->plxPlugins->aPlugins["Cameleon"]->normalize($this->plxMotor->aCats[$cat]["name"]);
					if (!empty($themes[$temp])){
						$theme=$temp;					
						break;
					}
				}
			}
			if (empty($theme)){$theme="defaut";}
		}
	
		$theme =$this->plxMotor->plxPlugins->aPlugins["Cameleon"]->normalize($theme);
		if (!empty($theme)&&isset($themes[$theme])){
			$this->plxMotor->style 			=$theme;
			$this->plxMotor->aConf["style"] =$theme;
			# Chargement du fichier de lang du theme
		
			$langfile = PLX_ROOT.$this->plxMotor->aConf["racine_themes"].$theme."/lang/".$this->plxMotor->aConf["default_lang"].".php";
			if(is_file($langfile)) {
				include($langfile);$this->lang = $LANG;
			}
		}
		?>';
		
	}
}





/* Pense-bete:
 * Récuperer des etres du fichier eters.xml
 *	$this->getParam("<nom du etre>")
 *	$this-> setParam ("1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("ThemeEndHead","1"))  ou eval($plxShow->callHook("ThemeEndHead",array("1","2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","1"));
 */